﻿Type=Service
Version=1.60
StartAtBoot=False
@EndOfDesignText@
'Version 1.04 - modified
Sub Process_Globals
	Dim hc As HttpClient
	Dim task As Int
	Dim countWorking As Int
	Dim finishTasks As Int
	Dim maxTasks As Int
	maxTasks = 10
	Dim taskToRequest As Map
	Dim TempFolder As String
	Dim Post As Boolean
	Dim PostBytes() As Byte
	Dim PostInputStream As InputStream
	Dim PostLength As Int
	Dim PostFileDir, PostFileName As String
	Dim hcIsInitialized As Boolean
	Dim OAuth As OAuth
	Dim boundary As String
	boundary = "A---------------------------1461124740692"
End Sub
Sub Service_Create
	If TempFolder = "" Then TempFolder = File.DirInternalCache
	If OAuth.IsInitialized = False Then
		OAuth.Initialize(Main.developerKey, Main.developerSecret)
	End If
	If hcIsInitialized = False Then
		hc.Initialize("hc")
		hcIsInitialized = True
	End If
End Sub

Sub Service_Start
	If HttpUtils.Tasks.IsInitialized = False Then Return
	taskToRequest.Initialize
	finishTasks = 0
	task = 0
	countWorking = 0
	Do While task < HttpUtils.Tasks.Size
		ProcessNextTask
		If countWorking >= maxTasks Then Exit
	Loop
End Sub
Sub ProcessNextTask
	If finishTasks >= HttpUtils.Tasks.Size Then
		HttpUtils.Working = False
		HttpUtils.Complete = True
		'Raise job done event
		If HttpUtils.CallbackJobDoneSub <> "" Then
			CallSub2(HttpUtils.CallbackActivity, HttpUtils.CallbackJobDoneSub, HttpUtils.Job)
		End If
		'If no new job was started then we kill this service.
		If HttpUtils.Working = False Then
			StopService("")
		End If
		Return
	End If
	If task >= HttpUtils.Tasks.Size Then Return
	Dim link As String
	link = HttpUtils.Tasks.Get(task)
	Dim req As HttpRequest
	If Post Then
		req = PrepareFileToUpload(link, PostFileDir, PostFileName)
	Else
		req.InitializeGet(link)
		OAuth.Sign(req) '<-- New: sign request
	End If
	
	'Here you can modify the request object if needed
	countWorking = countWorking + 1
	taskToRequest.Put(task, link)
	hc.Execute(req, task)
	task = task + 1
End Sub
Sub PrepareFileToUpload (link As String, Dir As String, FileName As String) As HttpRequest
	Dim req As HttpRequest
	req.InitializePost2(link, ("file=" & HttpUtils.EncodeUrl(FileName)).GetBytes("UTF8"))
	req.SetContentType("application/x-www-form-urlencoded")
	OAuth.Sign(req)
	Dim authHeader As String
	authHeader = OAuth.GetAuthorizationHeaderValue(req)
	
	'write the file
	Dim stream As OutputStream
	stream.InitializeToBytesArray(20)
	Dim EOL As String
	EOL = Chr(13) & Chr(10) 'CRLF constant matches Android end of line character which is chr(10).
	Dim b() As Byte
	b = ("--" & boundary & EOL & "Content-Disposition: form-data; name=" _ 
		& QUOTE & "file" & QUOTE & "; filename=" & QUOTE & FileName & QUOTE _
		& EOL & "Content-Type: " & "application/octet-stream" & EOL & _ 
		"Content-Transfer-Encoding: binary" & EOL & EOL).GetBytes("UTF8")
	stream.WriteBytes(b, 0, b.Length)
	Dim in As InputStream
	in = File.OpenInput(Dir, FileName)
	File.Copy2(in, stream) 'read the file and write it to the stream
	b = EOL.GetBytes("UTF8")
	stream.WriteBytes(b, 0, b.Length)
	
	b = (EOL & "--" & boundary & "--" & EOL).GetBytes("UTF8")
	stream.WriteBytes(b, 0, b.Length)
	b = stream.ToBytesArray
	
	Dim req As HttpRequest
	req.InitializePost2(link, b)
	req.SetContentType("multipart/form-data; boundary=" & boundary)
	req.SetContentEncoding("UTF8")
	req.SetHeader("Authorization", authHeader)
	Return req
End Sub
Sub hc_ResponseSuccess (Response As HttpResponse, TaskId As Int)
	Response.GetAsynchronously("response", File.OpenOutput(TempFolder, TaskId, False), _
		True, TaskId)
End Sub
Sub Response_StreamFinish (Success As Boolean, TaskId As Int)
	finishTasks = finishTasks + 1
	countWorking = countWorking - 1
	If Success = False Then
		HandleError(TaskId, LastException.Message)
		ToastMessageShow("Error: " & LastException.Message, True)
	Else
		HttpUtils.SuccessfulUrls.Put(taskToRequest.Get(TaskId), TaskId)
		'Raise URL done event
		If HttpUtils.CallbackUrlDoneSub <> "" Then
			CallSub2(HttpUtils.CallbackActivity, HttpUtils.CallbackUrlDoneSub, taskToRequest.Get(TaskId))
		End If
	End If
	ProcessNextTask
End Sub
Sub hc_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	countWorking = countWorking - 1
	finishTasks = finishTasks + 1
	HandleError(TaskId, Reason)
	Dim errorMessage As StringBuilder
	errorMessage.Initialize
	errorMessage.Append("Error: StatusCode=" & StatusCode & ", ")
	If Response <> Null Then
		Dim s As String
		s = Response.GetString("UTF8")
		Try
			Dim j As JSONParser
			j.Initialize(s)
			s = j.NextObject.Get("error")
		Catch
			Log("Error message is not Json.")
		End Try
		errorMessage.Append(s)
		Response.Release
	Else
		errorMessage.Append(Reason)
	End If
	ToastMessageShow(errorMessage.ToString, True)
	Log(errorMessage.ToString)
	If StatusCode = 401 Then 'We need to get a new token
		StartActivity(UserForm)
	End If
	ProcessNextTask
End Sub
Sub HandleError(TaskId As Int, Reason As String)
	Dim link As String
	link = TaskToRequest.Get(TaskId)
	Log("Error. Url=" & link & " Message=" & Reason)
End Sub
Sub Service_Destroy
	HttpUtils.Working = False
End Sub
